From 854493b6bd66ed36a472652889bbfbbd50ade009 Mon Sep 17 00:00:00 2001
From: blsaws <bryan.sullivan@att.com>
Date: Mon, 8 Aug 2016 06:05:18 -0700
Subject: Further updates in testing. Addressing further tweaks to blueprint.

JIRA: MODELS-23

Change-Id: Ia2e2a141a6a7ef7270529ed63892fa624be04ff0
Signed-off-by: blsaws <bryan.sullivan@att.com>
---
 tests/utils/cloudify-clean.sh |  12 ++++-
 tests/utils/cloudify-setup.sh |  94 +++++++++++++++++++-------------------
 tests/vHello.sh               | 102 +++++++++++++++++++++++++++++++++---------
 3 files changed, 141 insertions(+), 67 deletions(-)

(limited to 'tests')

diff --git a/tests/utils/cloudify-clean.sh b/tests/utils/cloudify-clean.sh
index 594afec..f5bd487 100644
--- a/tests/utils/cloudify-clean.sh
+++ b/tests/utils/cloudify-clean.sh
@@ -23,6 +23,12 @@
 #
 # How to use:
 #   $ bash cloudify-clean.sh
+#
+# Extra commands useful in debugging:
+# Delete all security groups created by Cloudify
+# sg=($(openstack security group list|awk "/ security_group_local_security_group_/ { print \$2 }")); for id in ${sg[@]}; do openstack security group delete ${id}; done
+# Delete all floating IPs
+# flip=($(neutron floatingip-list|grep -v "+"|grep -v id|awk '{print $2}')); for id in ${flip[@]}; do neutron floatingip-delete ${id}; done
 
 function setenv () {
 mkdir /tmp/cloudify
@@ -91,7 +97,7 @@ neutron port-delete cloudify-manager-port
 echo "cloudify-clean.sh: delete other ports"
 port=($(neutron port-list|grep -v "+"|grep -v name|awk '{print $2}')); for id in ${port[@]}; do neutron port-delete ${id}; done
 
-echo "cloudify-clean.sh: delete cloudify securituy groups"
+echo "cloudify-clean.sh: delete cloudify security groups"
 openstack security group delete cloudify-sg-manager 
 openstack security group delete cloudify-sg-agents 
 
@@ -113,3 +119,7 @@ openstack keypair delete cloudify-manager
 echo "cloudify-clean.sh: delete cloudify-agent keypair"
 openstack keypair delete cloudify-agent
 
+echo "cloudify-clean.sh: delete cloudify container"
+CONTAINER=$(sudo docker ps -l | awk "/ ubuntu:xenial / { print \$1 }")
+sudo docker stop $CONTAINER
+sudo docker rm -v $CONTAINER
diff --git a/tests/utils/cloudify-setup.sh b/tests/utils/cloudify-setup.sh
index 98945f0..45cea3b 100644
--- a/tests/utils/cloudify-setup.sh
+++ b/tests/utils/cloudify-setup.sh
@@ -88,7 +88,7 @@ function get_external_net () {
 }
 
 dist=`grep DISTRIB_ID /etc/*-release | awk -F '=' '{print $2}'`
-if [ "$1" == "1" ]; then
+if [ "$2" == "1" ]; then
   echo "cloudify-setup.sh: Copy this script to /tmp/cloudify"
   cp $0 /tmp/cloudify/.
   chmod 755 /tmp/cloudify/*.sh
@@ -105,7 +105,7 @@ if [ "$1" == "1" ]; then
     exit 0
   fi
 else 
-  if [ "$1" == "2" ]; then
+  if [ "$2" == "2" ]; then
     echo "cloudify-setup.sh: Install dependencies - OS specific"
     if [ "$dist" == "Ubuntu" ]; then
       apt-get update
@@ -153,64 +153,66 @@ python get-cloudify.py --upgrade
 echo "cloudify-setup.sh: Initialize Cloudify"
 cfy init
 
-echo "cloudify-setup.sh: Prepare the Cloudify Manager data"
-mkdir -p ~/cloudify-manager
-cd ~/cloudify-manager
-wget https://github.com/cloudify-cosmo/cloudify-manager-blueprints/archive/3.4.tar.gz
-mv 3.4.tar.gz cloudify-manager-blueprints.tar.gz
-tar -xzvf cloudify-manager-blueprints.tar.gz
-cd cloudify-manager-blueprints-3.4
-
 echo "cloudify-setup.sh: Setup admin-openrc.sh"
 source /tmp/cloudify/admin-openrc.sh
 
-echo "cloudify-setup.sh: Setup keystone_username"
-sed -i -- "s/keystone_username: ''/keystone_username: '$OS_USERNAME'/g" openstack-manager-blueprint-inputs.yaml
+if [ "$1" == "cloudify-manager" ]; then
+  echo "cloudify-setup.sh: Prepare the Cloudify Manager data"
+  mkdir -p ~/cloudify-manager
+  cd ~/cloudify-manager
+  wget https://github.com/cloudify-cosmo/cloudify-manager-blueprints/archive/3.4.tar.gz
+  mv 3.4.tar.gz cloudify-manager-blueprints.tar.gz
+  tar -xzvf cloudify-manager-blueprints.tar.gz
+  cd cloudify-manager-blueprints-3.4
 
-echo "cloudify-setup.sh: Setup keystone_password"
-sed -i -- "s/keystone_password: ''/keystone_password: '$OS_PASSWORD'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup keystone_username"
+  sed -i -- "s/keystone_username: ''/keystone_username: '$OS_USERNAME'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup keystone_tenant_name"
-sed -i -- "s/keystone_tenant_name: ''/keystone_tenant_name: '$OS_TENANT_NAME'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup keystone_password"
+  sed -i -- "s/keystone_password: ''/keystone_password: '$OS_PASSWORD'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup keystone_url"
-# Use ~ instead of / as regex delimeter, since this variable contains slashes
-sed -i -- "s~keystone_url: ''~keystone_url: '$OS_AUTH_URL'~g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup keystone_tenant_name"
+  sed -i -- "s/keystone_tenant_name: ''/keystone_tenant_name: '$OS_TENANT_NAME'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup region"
-sed -i -- "s/region: ''/region: '$OS_REGION_NAME'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup keystone_url"
+  # Use ~ instead of / as regex delimeter, since this variable contains slashes
+  sed -i -- "s~keystone_url: ''~keystone_url: '$OS_AUTH_URL'~g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup manager_public_key_name"
-sed -i -- "s/#manager_public_key_name: ''/manager_public_key_name: 'cloudify-manager'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup region"
+  sed -i -- "s/region: ''/region: '$OS_REGION_NAME'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup agent_public_key_name"
-sed -i -- "s/#agent_public_key_name: ''/agent_public_key_name: 'cloudify-agent'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup manager_public_key_name"
+  sed -i -- "s/#manager_public_key_name: ''/manager_public_key_name: 'cloudify-manager'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup image_id"
-# CentOS-7-x86_64-GenericCloud.qcow2 failed to be routable (?), so changed to 1607 version
-image=$(openstack image list | awk "/ CentOS-7-x86_64-GenericCloud-1607 / { print \$2 }")
-if [ -z $image ]; then glance --os-image-api-version 1 image-create --name CentOS-7-x86_64-GenericCloud-1607 --disk-format qcow2 --location http://cloud.centos.org/centos/7/images/CentOS-7-x86_64-GenericCloud.qcow2-1607 --container-format bare
-fi
-image=$(openstack image list | awk "/ CentOS-7-x86_64-GenericCloud-1607 / { print \$2 }")
-sed -i -- "s/image_id: ''/image_id: '$image'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup agent_public_key_name"
+  sed -i -- "s/#agent_public_key_name: ''/agent_public_key_name: 'cloudify-agent'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup flavor_id"
-flavor=$(nova flavor-show m1.large | awk "/ id / { print \$4 }")
-sed -i -- "s/flavor_id: ''/flavor_id: '$flavor'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup image_id"
+  # CentOS-7-x86_64-GenericCloud.qcow2 failed to be routable (?), so changed to 1607 version
+  image=$(openstack image list | awk "/ CentOS-7-x86_64-GenericCloud-1607 / { print \$2 }")
+  if [ -z $image ]; then 
+    glance --os-image-api-version 1 image-create --name CentOS-7-x86_64-GenericCloud-1607 --disk-format qcow2 --location http://cloud.centos.org/centos/7/images/CentOS-7-x86_64-GenericCloud.qcow2-1607 --container-format bare
+  fi
+  image=$(openstack image list | awk "/ CentOS-7-x86_64-GenericCloud-1607 / { print \$2 }")
+  sed -i -- "s/image_id: ''/image_id: '$image'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Setup external_network_name"
-get_external_net
-sed -i -- "s/external_network_name: ''/external_network_name: '$EXTERNAL_NETWORK_NAME'/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup flavor_id"
+  flavor=$(nova flavor-show m1.large | awk "/ id / { print \$4 }")
+  sed -i -- "s/flavor_id: ''/flavor_id: '$flavor'/g" openstack-manager-blueprint-inputs.yaml
 
-# By default, only the cloudify-management-router is setup as DNS server, and it was failing to resolve internet domain names, which was blocking download of needed resources
-echo "cloudify-setup.sh: Add nameservers"
-sed -i -- "s/#management_subnet_dns_nameservers: \[\]/management_subnet_dns_nameservers: \[8.8.8.8\]/g" openstack-manager-blueprint-inputs.yaml
+  echo "cloudify-setup.sh: Setup external_network_name"
+  get_external_net
+  sed -i -- "s/external_network_name: ''/external_network_name: '$EXTERNAL_NETWORK_NAME'/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: Bootstrap the manager"
-cfy bootstrap --install-plugins --keep-up-on-failure -p openstack-manager-blueprint.yaml -i openstack-manager-blueprint-inputs.yaml
+  # By default, only the cloudify-management-router is setup as DNS server, and it was failing to resolve internet domain names, which was blocking download of needed resources
+  echo "cloudify-setup.sh: Add nameservers"
+  sed -i -- "s/#management_subnet_dns_nameservers: \[\]/management_subnet_dns_nameservers: \[8.8.8.8\]/g" openstack-manager-blueprint-inputs.yaml
 
-echo "cloudify-setup.sh: install needed packages on the manager to support blueprints 'not using managed plugins'"
-# See https://cloudifysource.atlassian.net/browse/CFY-5050
-cfy ssh -c "sudo yum install -y gcc gcc-c++ python-devel"
+  echo "cloudify-setup.sh: Bootstrap the manager"
+  cfy bootstrap --install-plugins --keep-up-on-failure -p openstack-manager-blueprint.yaml -i openstack-manager-blueprint-inputs.yaml
 
+  echo "cloudify-setup.sh: install needed packages to support blueprints 'not using managed plugins'"
+  # See https://cloudifysource.atlassian.net/browse/CFY-5050
+  cfy ssh -c "sudo yum install -y gcc gcc-c++ python-devel"
+fi
 
diff --git a/tests/vHello.sh b/tests/vHello.sh
index 6c294bc..ff9d38f 100644
--- a/tests/vHello.sh
+++ b/tests/vHello.sh
@@ -25,6 +25,8 @@
 #   start: run test
 #   clean: cleanup after test
 
+set -x
+
 pass() {
   echo "Hooray!"
   set +x #echo off
@@ -39,6 +41,19 @@ fail() {
   exit 1
 }
 
+function get_floating_net () {
+  network_ids=($(neutron net-list|grep -v "+"|grep -v name|awk '{print $2}'))
+  for id in ${network_ids[@]}; do
+      [[ $(neutron net-show ${id}|grep 'router:external'|grep -i "true") != "" ]] && floating_network_id=${id}
+  done
+  if [[ $floating_network_id ]]; then 
+    floating_network_name=$(openstack network show $floating_network_id | awk "/ name / { print \$4 }")
+  else
+    echo "vHello.sh: Floating network not found"
+    exit 1
+  fi
+}
+
 select_manager() {
   echo "vHello.sh: select manager to use"
   MANAGER_IP=$(openstack server list | awk "/ cloudify-manager-server / { print \$9 }")
@@ -57,40 +72,87 @@ start() {
   cd cloudify-hello-world-example
   git checkout 3.4.1-build
 
+  echo "vHello.sh: setup OpenStack CLI environment"
+  source /tmp/cloudify/admin-openrc.sh
+
   echo "vHello.sh: create blueprint inputs file"
   # Set host image per Cloudify agent compatibility: http://docs.getcloudify.org/3.4.0/agents/overview/
+  cd /tmp/cloudify/blueprints
   cat <<EOF >vHello-inputs.yaml
-  image: CentOS-7-x86_64-GenericCloud-1607
-  flavor: m1.small
-  agent_user: centos
-  webserver_port: 8080
+image: CentOS-7-x86_64-GenericCloud-1607
+flavor: m1.small
+agent_user: centos
+webserver_port: 8080
+EOF
+
+# Workarounds for error in allocating floating IP 
+# Workflow failed: Task failed 'neutron_plugin.floatingip.create' -> Failed to parse request. Required attribute 'floating_network_id' not specified [status_code=400]
+  get_floating_net
+
+  if [[ "$1" == "cloudify-cli" ]]; then 
+    echo "vHello.sh: update blueprint with parameters needed for Cloudify CLI use"
+    cat <<EOF >>vHello-inputs.yaml
+external_network_name: $floating_network_name
+EOF
+
+    sed -i -- 's/description: Openstack flavor name or id to use for the new server/description: Openstack flavor name or id to use for the new server\n  external_network_name:\n    description: External network name/g' cloudify-hello-world-example/blueprint.yaml
+
+    sed -i -- 's/type: cloudify.openstack.nodes.FloatingIP/type: cloudify.openstack.nodes.FloatingIP\n    properties:\n      floatingip:\n        floating_network_name: { get_input: external_network_name }/g' cloudify-hello-world-example/blueprint.yaml
+
+# Workarounds for error in allocating keypair
+# Task failed 'nova_plugin.server.create' -> server must have a keypair, yet no keypair was connected to the server node, the "key_name" nested property wasn't used, and there is no agent keypair in the provider context
+# Tried the following but keypair is not supported by http://www.getcloudify.org/spec/openstack-plugin/1.4/plugin.yaml
+#    sed -i -- 's/target: security_group/target: security_group\n      - type: cloudify.openstack.server_connected_to_keypair\n        target: keypair/g' cloudify-hello-world-example/blueprint.yaml
+
+    sed -i -- 's/description: External network name/description: External network name\n  private_key_path:\n    description: Path to private key/g' cloudify-hello-world-example/blueprint.yaml
+
+    sed -i -- '0,/interfaces:/s//interfaces:\n      cloudify.interfaces.lifecycle:\n        start:\n          implementation: openstack.nova_plugin.server.start\n          inputs:\n            private_key_path:  { get_input: private_key_path }/' cloudify-hello-world-example/blueprint.yaml
+
+    echo "vHello.sh: Create Nova key pair"
+    mkdir -p ~/.ssh
+    nova keypair-delete vHello
+    nova keypair-add vHello > ~/.ssh/vHello.pem
+    chmod 600 ~/.ssh/vHello.pem
+
+    echo "vHello.sh: update blueprint with parameters needed for Cloudify CLI use"
+    cat <<EOF >>vHello-inputs.yaml
+private_key_path: /root/.ssh/vHello.pem
 EOF
+  fi
 
   echo "vHello.sh: activate cloudify Virtualenv"
   source ~/cloudify/venv/bin/activate
 
-  echo "vHello.sh: setup OpenStack CLI environment"
-  source /tmp/cloudify/admin-openrc.sh
-
   echo "vHello.sh: initialize cloudify environment"
   cd /tmp/cloudify/blueprints
   cfy init -r
 
-  if [[ "$1" == "cloudify-manager" ]]; then select_manager; fi
-
-  echo "vHello.sh: upload blueprint to manager"
-  cfy blueprints delete -b cloudify-hello-world-example
-  cfy blueprints upload -p cloudify-hello-world-example/blueprint.yaml -b cloudify-hello-world-example
-  if [ $? -eq 1 ]; then fail; fi
+  if [[ "$1" == "cloudify-manager" ]]; then 
+    select_manager
+    echo "vHello.sh: upload blueprint via manager"
+    cfy blueprints delete -b cloudify-hello-world-example
+    cfy blueprints upload -p cloudify-hello-world-example/blueprint.yaml -b cloudify-hello-world-example
+    if [ $? -eq 1 ]; then fail; fi
 
-  echo "vHello.sh: create vHello deployment"
-  cd /tmp/cloudify/blueprints/cloudify-hello-world-example
-  cfy deployments create --debug -d vHello -i vHello-inputs.yaml -b cloudify-hello-world-example
-  if [ $? -eq 1 ]; then fail; fi
+    echo "vHello.sh: create vHello deployment via manager"
+    cd /tmp/cloudify/blueprints/cloudify-hello-world-example
+    cfy deployments create --debug -d vHello -i vHello-inputs.yaml -b cloudify-hello-world-example
+    if [ $? -eq 1 ]; then fail; fi
 
-  echo "vHello.sh: execute 'install' workflow for vHello deployment"
-  cfy executions start -w install -d vHello --timeout 1800
-  if [ $? -eq 1 ]; then fail; fi
+    echo "vHello.sh: execute 'install' workflow for vHello deployment via manager"
+    cfy executions start -w install -d vHello --timeout 1800
+    if [ $? -eq 1 ]; then fail; fi
+  else 
+    echo "vHello.sh: install local blueprint"
+    cfy local install --install-plugins -i vHello-inputs.yaml -p cloudify-hello-world-example/blueprint.yaml --allow-custom-parameters --parameters="floating_network_name=$floating_network_name"
+    if [ $? -eq 1 ]; then fail; fi
+#    cfy local install replaces the following, per http://getcloudify.org/2016/04/07/cloudify-update-from-developers-features-improvements-open-source-python-devops.html
+#    cfy local init --install-plugins -i vHello-inputs.yaml -p cloudify-hello-world-example/blueprint.yaml 
+#    cfy local execute -w install
+#    Not sure if needed
+#    cfy local create-requirements -p cloudify-hello-world-example/blueprint.yaml
+#    if [ $? -eq 1 ]; then fail; fi
+  fi
 
   echo "vHello.sh: verify vHello server is running"
   SERVER_IP=$(cfy deployments outputs -d vHello | awk "/ Value: / { print \$2 }")
-- 
cgit